(function($) {
    window.wxc = window.wxc || {};
    window.wxc.xcConfirm = function(popHtml, type, options) {
        var btnType = window.wxc.xcConfirm.btnEnum;
        var eventType = window.wxc.xcConfirm.eventEnum;
        var popType = { info: { title: "信息", icon: "0 0", btn: btnType.ok },
        success: { title: "成功", icon: "0 -48px", btn: btnType.ok },
        error: { title: "错误", icon: "-48px -48px", btn: btnType.ok },
        confirm: { title: "更新提示", icon: "-48px 0", btn: btnType.okcancel },
        warning: { title: "警告", icon: "0 -96px", btn: btnType.okcancel },
        input: { title: "添加播放", icon: "", btn: btnType.ok },
        custom: { title: "选择视频", icon: "", btn: btnType.okcancel },
        addsite: { title: "收藏网址", icon: "", btn: btnType.ok }};
        var itype = type ? type instanceof Object ? type : popType[type] || {} : {};
        var config = $.extend(true, { title: "", icon: "", btn: btnType.ok, onOk: $.noop, onCancel: $.noop, onClose: $.noop }, itype, options);
        var $txt = $("<p>").html(popHtml);
        var $tt = $("<span>").addClass("tt").text(config.title);
        var icon = config.icon;
        var $icon = icon ? $("<div>").addClass("bigIcon").css("backgroundPosition", icon) : "";
        var btn = config.btn;
        var popId = creatPopId();
        var $box = $("<div>").addClass("xcConfirm");
        var $layer = $("<div>").addClass("xc_layer");
        var $popBox = $("<div>").addClass("popBox");
        var $ttBox = $("<div>").addClass("ttBox");
        var $txtBox = $("<div>").addClass("txtBox");
        var $btnArea = $("<div>").addClass("btnArea");
        var $ok = $("<a>").addClass("sgBtn").addClass("ok").text("确定");
        var $cancel = $("<a>").addClass("sgBtn").addClass("cancel").text("取消");
        var $input = $("<input>").addClass("inputBox").attr("placeholder","支持magnet/http/ftp/ed2k/rtmp/mms/");
        var $clsBtn = $("<a>").addClass("clsBtn");
        var btns = { ok: $ok, cancel: $cancel };
        init();

        function init() {
            if (popType["input"] === itype) { $txt.append($input); }
            creatDom();
            bind();
            // 磁力文件上传 是否播放
            $("#upfile3").change(function() {
                doCancel();
                var id = this.id;
                var formData = new FormData;
                var file = this.files[0];
                var processbar = null;
                formData.append("file", file, encodeURI(file.uploadName || file.name));
                $.ajax({
                    type: "POST",
                    url:"/torrent/upload",
                    dataType: "json",
                    data: formData,
                    processData: false,
                    contentType: false,
                    xhr: function() {
                        var xhr = $.ajaxSettings.xhr();
                        if(xhr.upload){
                            xhr.upload.addEventListener("progress", function(e) {
                                if(processbar){
                                    var p = Math.floor(100 * e.loaded / e.total) + "%";
                                    processbar.css({
                                        width: p
                                    }).text(p);
                                }
                                if(e.loaded == e.total) $(id).val("");
                            }, false);
                        }
                        return xhr;
                    },
                    beforeSend: function() {
                        if(processbar){
                            processbar.css({
                                width: "1%"
                            }).text("")
                        }
                    },
                    success: function(data) {
                        if(data.success){
                            if(id == "upfile3"){
                                alert("种子文件已上传并解析，请选择要播放的视频文件。");
                                if(data.files && data.files.length){
                                    var txt="<select id=\"torrentItems\">";
                                    for(var i=0; i<data.files.length; i++){
                                        var f = data.files[i];
                                        txt = txt + "<option value='" + f.index + "'>" + f.name + "(" + formatSize(f.size) + ")</option>";
                                    }
                                    txt = txt + "</select>";
                                    <!--torrentItems.val(data.files[0].index);-->
                                    $("#torrent_path").val(""+data.torrentpath);
                                     window.wxc.xcConfirm(txt, window.wxc.xcConfirm.typeEnum.custom,{
                                        onOk:function(v){
                                          var torrentItems = $("#torrentItems");
                                          var videoIndex = torrentItems.val();
                                          var torrent_path = $("#torrent_path").val();
                                          console.log(videoIndex+"---|||---"+torrent_path);
                                           $.post('/torrent/play', {"videoIndex":videoIndex, "useSystem":$('#playUseSystem')[0].checked,"torrentpath":torrent_path}, function(data){
                                                console.log(data);
                                           });
                                        }
                                    });
                                }
                            }
                        }else{
                            alert("抱歉，文件上传失败！");
                        }
                    }
                });
            });

             // 本地视频文件上传 是否播放
            $("#upfile").change(function() {
                        doCancel();
                        var txt="<div class=\"upload-process\">"+
                                 "<div class=\"processbar\" id=\"processbar1\"></div>"+
                                 "</div>";
                        window.wxc.xcConfirm(txt, window.wxc.xcConfirm.typeEnum.custom,{
                            onOk:function(v){

                            }
                        });
                        var id = this.id;
                        var processbar1=$("#processbar1");
                        var formData = new FormData;
                        var file = this.files[0];
                        if(id == "upfile"){
                            formData.append("autoInstall", true);
                        }
                        formData.append("file", file, encodeURI(file.uploadName || file.name));
                        $.ajax({
                            type: "POST",
                            url: "/upload",
                            dataType: "json",
                            data: formData,
                            processData: false,
                            contentType: false,
                            xhr: function() {
                                var xhr = $.ajaxSettings.xhr();
                                if(xhr.upload){
                                    xhr.upload.addEventListener("progress", function(e) {
                                        if(processbar1){
                                            var p = Math.floor(100 * e.loaded / e.total) + "%";
                                            processbar1.css({
                                                width: p
                                            }).text(p);
                                        }
                                        if(e.loaded == e.total) $(id).val("");
                                    }, false);
                                }
                                return xhr;
                            },
                            beforeSend: function() {
                                if(processbar1){
                                    processbar1.css({
                                        width: "1%"
                                    }).text("")
                                }
                            },
                            success: function(data) {
                                if(data.success){
                                    $('#cancel').click();
                                    if(file.name.indexOf(".apk") != -1){
                                        alert("软件已安装,请留意电视机的安装请求.");
                                    }else{
                                        alert("文件已成功传送到TV盒子,存储于：" + data.filePath);
                                    }
                                }else{
                                    alert("文件上传失败!");
                                }
                            }
                        });
                    });

            $("#addsite").on("click", function(){
                doCancel();
                var txt="<div style=\"width:90%;text-align: center;\">"+
                                             "<input type=\"text\" id=\"site_name\" placeholder=\"名称\">"+
                                             "<input type=\"text\" id=\"site_url\" placeholder=\"链接\">"+
                                         "</div>";
                     window.wxc.xcConfirm(txt, window.wxc.xcConfirm.typeEnum.addsite,{
                         onOk:function(v){
                             var sitename = $("#site_name").val();
                             var siteurl = $("#site_url").val();
                             console.log(sitename + '------' + siteurl);
                             if(sitename == null || sitename == '' || siteurl == null || siteurl == ''){
                                 alert('名称/链接不能为空');
                                 return;
                             }
                             var Expression=/http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
                             var objExp=new RegExp(Expression);
                             if(objExp.test(siteurl) != true){
                                 alert("网址格式不正确!");
                                 return false;
                             }
                             $.post("/collectsite", {"sitename":sitename,"siteurl":siteurl}, function(data){
                                 alert('收藏成功');
                                 $.post("/getcollectsite", {"":""}, function(data){
                                    if(data != '' && data != null){
                                         $("#siteitems").empty();
                                         $("#siteitems1").empty();
                                         $("#siteitems2").empty();
                                         var websiteUrls =  data.split('%%%');
                                         for(var i = 0; i < websiteUrls.length; i++){
                                             var sites = websiteUrls[i];
                                             var keys = sites.split(',');
                                             if(i<=4){
                                                  $("#siteitems").append(
                                                     '   <div>'+
                                                     '   <img id=\"delete\" src=\"/delete_1.png\" style=\"height:15px;width:15px;float: right;display: block;margin-left: 8%;position: relative;left: -5px;display: none;\">'+
                                                     '<div id=\"delete_site\" class=\"collect\">' +
                                                     '      <a href=\"' + keys[1] + '\" target=\"_blank\"  style=\"text-decoration: none;\">' +
                                                     '           <p class=\"collecttext\">'+keys[0]+'</p>    ' +
                                                     '      </a>' +
                                                     '  </div>'+
                                                     '   </div>');
                                             }
                                             if(i > 4 && i<=9){
                                                 $("#siteitems1").css("display","");
                                                 $("#siteitems1").append(
                                                     '<div>'+
                                                     '<img id=\"delete\" src=\"/delete_1.png\" style=\"height:15px;width:15px;float: right;display: block;margin-left: 8%;position: relative;left: -5px;display: none;\">'+
                                                     '<div id=\"delete_site\" class=\"collect\">' +
                                                     '      <a href=\"' + keys[1] + '\" target=\"_blank\"  style=\"text-decoration: none;\">' +
                                                     '           <p class=\"collecttext\">'+keys[0]+'</p>    ' +
                                                     '      </a>' +
                                                     '  </div>'+
                                                     '  </div>');
                                             }
                                             if(i > 9){
                                                 $("#siteitems2").css("display","");
                                                 $("#siteitems2").append(
                                                     '<div>'+
                                                     '<img id=\"delete\" src=\"/delete_1.png\" style=\"height:15px;width:15px;float: right;display: block;margin-left: 8%;position: relative;left: -5px;display: none;\">'+
                                                     '<div id=\"delete_site\" class=\"collect\">' +
                                                     '      <a href=\"' + keys[1] + '\"  target=\"_blank\"  style=\"text-decoration: none;\">' +
                                                     '           <p class=\"collecttext\">'+keys[0]+'</p>    ' +
                                                     '      </a>' +
                                                     '  </div>'+
                                                     '  </div>');
                                             }
                                         }
                                    }else{
                                         console.log("无数据");
                                    }
                                 });
                             });
                     }
                });
            })
             $("#delsite").on("click", function(){
                doCancel();
                $("[id=delete]").each(function(){
                    if($(this).css("display")=="none"){
                        $(this).css("display","");
                    }else{
                        $(this).css("display","none");
                    }
                });
            });
        }

        function creatDom() {
            $popBox.append($ttBox.append($clsBtn).append($tt)).append($txtBox.append($icon).append($txt)).append($btnArea.append(creatBtnGroup(btn)));
            $box.attr("id", popId).append($layer).append($popBox);
            $("body").append($box);
            $(".clsBtn").text('x');
        }

        function bind() { $ok.click(doOk);
            $(window).bind("keydown", function(e) { if (e.keyCode == 13) { if ($("#" + popId).length == 1) { doOk(); } } });
            $cancel.click(doCancel);
            $clsBtn.click(doClose);
            }

        function doOk() {
            var $o = $(this);
            var v = $.trim($input.val());
            if ($input.is(":visible"))
                config.onOk(v);
            else
                config.onOk();
            $("#" + popId).remove();
            config.onClose(eventType.ok);
        }

        function doCancel() {
            var $o = $(this);
            config.onCancel();
            $("#" + popId).remove();
            config.onClose(eventType.cancel);
         }

        function initVersion(){
            $.post("/initVersion", {}, function(data){
               if(data == 'ok'){
                 var text = "请打开云雀助手,更新APP。";
                 window.wxc.xcConfirm(text, window.wxc.xcConfirm.typeEnum.confirm,{
                    doCancel:function(v){
                    }
                });
               }
            });
        }

        function doClose() {
            $("#" + popId).remove();
            config.onClose(eventType.close);
            $(window).unbind("keydown");
            }

        function creatBtnGroup(tp) { var $bgp = $("<div>").addClass("btnGroup");
            $.each(btns, function(i, n) { if (btnType[i] == (tp & btnType[i])) { $bgp.append(n); } }); return $bgp; }

        function creatPopId() { var i = "pop_" + (new Date()).getTime() + parseInt(Math.random() * 100000); if ($("#" + i).length > 0) { return creatPopId(); } else { return i; } }
    };
    window.wxc.xcConfirm.btnEnum = { ok: parseInt("0001", 2), cancel: parseInt("0010", 2), okcancel: parseInt("0011", 2) };
    window.wxc.xcConfirm.eventEnum = { ok: 1, cancel: 2, close: 3 };
    window.wxc.xcConfirm.typeEnum = { info: "info", success: "success", error: "error", confirm: "confirm", warning: "warning", input: "input", custom: "custom",addsite: "addsite" };
})(jQuery);